<?php
/*
Plugin Name: Smiley+Format Javascript Buttons
Plugin URI: http://cimddwc.net/
Description: Lets you display a row of clickable smilies and simple formatting buttons next to your comment textarea. Based on "Smiley Javascript Buttons" by Skippy <http://aranea.zuavra.net/>.
Version: 1.5.ag.2
Author: Andreas Groegel
Author URI: http://cimddwc.net/
License:

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

----

Additions compared to Skippy's original:
- options on top of this source file
- noscript hint made optional, and added translation function __()
- optional "more >>" link
- optional line breaks
- format buttons
(user comment field only)

*/

// Configurable variables:
//
// Show a hint for browsers/users without JavaScript? (1=yes, 0=no)
$SFJB_SHOW_NOSCRIPT = 0;

// Display a "more >>" link after this number of smilies - WordPress has 22 default smilies
// (so it's mainly useful to those who have added more :codes: in wp-includes/functions.php).
// Use 999 or higher to disable.
$SFJB_MORE_INDEX = 20;

// Force a line break <br> after these numbers of smilies:
$SFJB_MORE_BREAK1 = 22;
$SFJB_MORE_BREAK2 = 999;

// Buttons for simple HTML formatting: (1=yes, 0=no)
$SFJB_SHOW_FORMATS = 1;


$SFJB_FORMATS = array (
	array('show' => '<strong>bold</strong> start',		'code' => '&lt;strong&gt;'),
	array('show' => '<strong>bold</strong> end',		'code' => '&lt;/strong&gt;'),
	array('show' => '<em>italics</em> start',			'code' => '&lt;em&gt;'),
	array('show' => '<em>italics</em> end',				'code' => '&lt;/em&gt;'),
	array('show' => 'blockqoute start',					'code' => '&lt;blockquote&gt;'),
	array('show' => 'blockqoute end',					'code' => '&lt;/blockquote&gt;'),
	array('show' => 'image',							'code' => '&lt;img src=&#34;http://&#34; title=&#34;&#34;&gt;'),
	array('show' => 'link',								'code' => '&lt;a href=&#34;http://&#34; title=&#34;&#34;&gt;'),
	array('show' => '&amp;',							'code' => '&amp;amp;'),
	array('show' => '&lt;',								'code' => '&amp;lt;'),
	array('show' => '&gt;',								'code' => '&amp;gt;')
);

global $SJB_IMAGE_URL; $SJB_IMAGE_URL='';
global $SJB_SMILIES; $SJB_SMILIES=array();

function SJB_findImageURL() {
	$client_root = get_settings('siteurl');
	$server_root = str_replace("index.php","",$_SERVER['SCRIPT_FILENAME']);
	// define possible locations for the smilies
	$locations = array(
		// WP 2.x+
		'/wp-includes/images/smilies/',
		// WP 1.5.x
		'/wp-images/smilies/',
	);
	// find a good location
	foreach ($locations as $dir) {
		if (is_dir($server_root.'/'.$dir)) return $client_root.'/'.$dir;
	}
	// nothing found, for some reason;
	// output the entry for the latest WP and hope for the best
	return $client_root.'/'.$locations[0];
}

function SJB_getSmilies() {
	static $got_smilies;
	if ($got_smilies) return;
	global $wpsmiliestrans;
	global $SJB_IMAGE_URL, $SJB_SMILIES;

	$SJB_IMAGE_URL = SJB_findImageURL();
	if (!is_array($wpsmiliestrans)) smilies_init();
	$SJB_SMILIES = array_map('trim',array_flip($wpsmiliestrans));
	$got_smilies = true;
}

function SJB_outputSmilies($textarea_name='comment') {
	global $SJB_IMAGE_URL, $SJB_SMILIES;
	global $SFJB_SHOW_NOSCRIPT, $SFJB_MORE_INDEX, $SFJB_MORE_BREAK1, $SFJB_MORE_BREAK2, $SFJB_SHOW_FORMATS;

	SJB_getSmilies();

	// output JS functions
	//  (code in "if" statements to insert smiley codes at cursor position taken from
	//   Alex King's WP-Grins <http://alexking.org/projects/wordpress>)
	?><script type="text/javascript"><!--
	function sfjbAdd(text) {
		var comment=document.getElementById('<?=$textarea_name?>');
		if (document.selection) {
			comment.focus();
			sel = document.selection.createRange();
			sel.text = text;
			comment.focus();
		} else
		if (comment.selectionStart || comment.selectionStart == '0') {
			var startPos = comment.selectionStart;
			var endPos = comment.selectionEnd;
			var cursorPos = endPos;
			comment.value = comment.value.substring(0, startPos)
				+ text
				+ comment.value.substring(endPos, comment.value.length);
			cursorPos += text.length;
			comment.focus();
			comment.selectionStart = cursorPos;
			comment.selectionEnd = cursorPos;
		} else
			comment.value=comment.value+text;
	}
	//function for "more >>" link:
	<?php if ($SFJB_MORE_INDEX<999): ?>
	function sfjbMore(show) {
		var morespan=document.getElementById('sfjb-more');
		var morelink=document.getElementById('sfjb-morelink');
		var lesslink=document.getElementById('sfjb-lesslink');
		if (show) {
			morespan.style.display='';
			morelink.style.display='none';
			lesslink.style.display='';
		} else {
			morespan.style.display='none';
			morelink.style.display='';
			lesslink.style.display='none';
		}
	}
	<?php endif; ?>
	//--></script><?php

	// output format buttons:
	if ($SFJB_SHOW_FORMATS > 0) {
		global $SFJB_FORMATS;
		echo '<script type="text/javascript"><!--'."\n";
		echo "document.write('<div id=\"sfjb-formats\">');\n";
		foreach($SFJB_FORMATS as $format => $fmt) {
			echo "document.write('<a class=\"sfjb-format\" href=\"javascript:sfjbAdd(\\'".$fmt['code']."\\')\">" .
				str_replace(' ','&nbsp;',__($fmt['show'])) .
				 "</a> ');\n";
		}
		echo "document.write('</div>');\n";
		echo "//--></script>\n";
	}

	// output clickable smilies:
	echo '<script type="text/javascript"><!--'."\n";
	$i = 0;
	foreach($SJB_SMILIES as $img => $code) {
		echo "document.write('<a href=\"javascript:sfjbAdd(\\' ".addslashes($code)." \\')\">".
			"<img src=\"".$SJB_IMAGE_URL.$img."\" alt=\"".$code."\" class=\"wp-smiley\" title=\"".$code."\" />".
			 "</a> ');\n";
		$i++;
		if ($i==$SFJB_MORE_INDEX) {
			echo "document.write('<a id=\"sfjb-morelink\" href=\"javascript:sfjbMore(true);\">".__('more')."&nbsp;&raquo;</a>".
			     "<span id=\"sfjb-more\" style=\"display: none;\">');\n";
		}
		if (($i==$SFJB_MORE_BREAK1)||($i==$SFJB_MORE_BREAK2)) {
			echo "document.write('<br />');\n";
		}
	}
	if ($SFJB_MORE_INDEX<999) {
		echo "document.write('</span>');\n";
		echo "document.write('<a id=\"sfjb-lesslink\" href=\"javascript:sfjbMore(false);\" style=\"display: none;\">&laquo;&nbsp;".__('less')."</a>');\n";
	}
	echo "//--></script>\n";

	if ($SFJB_SHOW_NOSCRIPT>0) {
		echo '<noscript>';
		echo __('You could see format buttons and clickable smiley faces here if you had JavaScript activated.');
		echo '</noscript>';
	}
}

function SJB_adminSmilies() {
	global $SJB_SMILIES;
	if (!is_array($SJB_SMILIES)) SJB_getSmilies();

	$OUTPUT="<script type=\"text/Javascript\"><!--\n";
	$OUTPUT.="if(typeof(edButtons)!='undefined'){\n";
	$i=0;
	foreach($SJB_SMILIES as $img => $code) {
		$OUTPUT.="edButtons[edButtons.length]=new edButton('ed_smilie_'+".$i.",'".addslashes($code)."',' ".addslashes($code)."','','',-1);\n";
		$i++;
	}
	$OUTPUT.="}\n";
	$OUTPUT.='//--></script>';
	return $OUTPUT;
}
?>